

	
	
	
/////////////// BASE FUNCTIONS /////////////


	function reloadDialog() {
		location.reload();
	}
	
//-------------

	var allowSerialize = true;

	function makeUnselectable(node) {
		if (node.nodeType == 1) {
			node.setAttribute("unselectable", "on");
		}
		var child = node.firstChild;
		while (child) {
			makeUnselectable(child);
			child = child.nextSibling;
		}
		
		$('.inputNameInput').removeAttr('unselectable');
		$('body').removeAttr('unselectable');
		$('html').removeAttr('unselectable');
		$('ol').removeAttr('unselectable');
		$('input').removeAttr('unselectable');
		$('button').removeAttr('unselectable');
		$('label').removeAttr('unselectable');
		$('#confirmDelete').removeAttr('unselectable');
		$('#wrapper').removeAttr('unselectable');
	}
	
//-------------



	function getModelLayers(actionName) {
		allowSerialize = false;
		query = 'skp:getModelLayers@' + actionName;
		window.location.href = query;
		allowSerialize = true;
	}
	
//-------------


	function getActiveLayer() {
		window.location = 'skp:getActiveLayer@';
	}
	
//-------------


	function setActiveLayerFromRuby(layerID) {
		$(".enabled").removeClass("enabled").addClass("disabled");
		$("#layer_" + layerID).children("div").children(".active").removeClass("disabled").addClass("enabled");
	}
	
//-------------


	function setActiveLayerFromJS(layerID) {
		layerID = layerID.replace('layer_', '')
		window.location = 'skp:setActiveLayerFromJS@' + layerID;
	}
	
//-------------
	
	
	function addLayerFromRuby(layerName, layerID, parentID) {
	
		if ($("#layer_" + layerID).length == 0) { // layer doesn't exists yet in the DOM
			var layerStr = '<li id="layer_' + layerID + '" class="layer mjs-nestedSortable-no-nesting mjs-nestedSortable-leaf" unselectable="on"><div class="lidiv" unselectable="on"><div class="handle" unselectable="on"></div><div class="visibility visible" unselectable="on"></div><div class="active disabled" unselectable="on"></div><span class="inputName" ><input class="inputNameInput" type="text" value="' + layerName + '" /></span><span class="layerName"><span class="layerNameText" unselectable="on">' + layerName + '</span></span></div></li>'
			
			if (parentID && parentID != "null"){ //ID parentID is set, find it and append to it
				parentID = '#group_' + parentID;
				$(parentID).children("ol").append(layerStr);
			}
			else { //else, append normally
				if($('.ui-selected').length > 0) {
					$('.ui-selected').last().parent().after(layerStr);
				}
				else {
					$('.sortable').append(layerStr);
				}
			}
			
			if (allowSerialize == true) {
				storeSerialize();
			}
		}
		
	}
	
	
//-------------
	
	
	function addLayerFromJS() {
		window.location = 'skp:addLayerFromJS';
	}
	
//-------------
	
	
	function addGroup(groupName, groupID, parentID) {
	
		allowSerialize = false;
	
		if (!groupID) { // groupID not set, new group created from js, else created from ruby
			//Check if Group nb exists
			var groupNb = 1;
			while (true) {
				var groupName = 'Group ' + groupNb;
				if ($("span").filter(function() { return ($(this).text() === groupName) }).length) {
					groupNb++;
				} 
				else {
					break; // On quitte la boucle
				}
			}
	
			window.location = 'skp:addGroup@' + groupName;
		
			getLayerDictID();
			groupID = layerDictID;
			
			allowSerialize = true;
		}
		
		var groupStr = '<li id="group_' + groupID + '" class="group mjs-nestedSortable-branch mjs-nestedSortable-expanded"><div class="lidiv"><div class="handle"></div><div class="visibility visible"></div><span class="disclose"></span><span class="inputName" ><input class="inputNameInput" type="text" /></span><span class="layerName"><span class="layerNameText">' + groupName + '</span></span></div><ol></ol></li>';
		
		if (parentID && parentID != "null"){ //ID parentID is set, find it and append to it
			parentID = '#group_' + parentID;
			$(parentID).children("ol").append(groupStr);
		}
		else { //else, append normally
			if($('.ui-selected').length > 0) {
				$('.ui-selected').last().parent().after(groupStr);
			}
			else {
				$('.sortable').append(groupStr);
			}
		}
		
		if (allowSerialize == true) {
			storeSerialize();
		}
	}
	
//-------------
	
	
	function renameLayerFromJS(layerID, newLayerName) {
	
		var layerNameS = { "layerID":layerID, "newLayerName":newLayerName }; //Json
		var JsonLayerNameS = $.toJSON( layerNameS );
		window.location = 'skp:renameLayerFromJS@' + JsonLayerNameS;
		
	}
	
	
	function renameLayerFromRuby(layerID, layerName) {
	
		$("#layer_" + layerID).children("div").children(".layerName").children(".layerNameText").text(layerName);
		
	}
	
	
	function renameGroup(groupID, newGroupName) {
	
		groupID = groupID.replace('group_', '')
		var renameGroup = { "groupID":groupID, "newGroupName":newGroupName }; //Json
		var renameGroup2 = $.toJSON( renameGroup );
		window.location = 'skp:renameGroup@' + renameGroup2;
		
	}
	
	
//-------------
	
	
	function trash() {
	
		$('#id0').children('.lidiv').removeClass('ui-selected'); // Prevent Layer0 delete
		
		layerContent = false; //Reset
		
		$('.ui-selected').each(function() {
			if ($(this).parent().hasClass("group")) { // If Group
				$(this).parent().find('.lidiv').addClass('ui-selected'); // Select all nested layers and groups
			}
		});
		
		$('.ui-selected').each(function() {
			if ($(this).parent().hasClass("layer")) { // If layer
				if (layerContent == false) { // Continue while layerContent = false
					layerID = $(this).parent().attr('id');
					layerID = layerID.replace('layer_', '')
					window.location = 'skp:checkLayerForContent@' + layerID;
				}
			}
		});

		var deleteContent = false; // By default, don't delete contents
		if(layerContent == true){ // if layers have content, show popup
			$('#defaultDelete').attr('checked', true); // Check "move contents to default layer"
			$('#confirmDelete').show();
			$('#overlay').show();
			$(window).resize(); // Center delete popup
			
			$("#okDelete").click(function() {
				if ($('#deleteDelete').is(':checked')) { deleteContent = true; } // "delete contents" checked
				$('#confirmDelete').hide();
				$('#overlay').hide();
				trash2(deleteContent);
			});
			
			$("#cancelDelete").click(function() {
				$('#confirmDelete').hide();
				$('#overlay').hide();
			});
		}
		else {
			trash2(deleteContent);
		}
		
		deleteContent = false; // Reset
		storeSerialize();
	}


	function trash2(deleteGeom) {
		$('.ui-selected').each(function() { // First, deal with layers
			if ($(this).parent().hasClass("layer")) { // If layer
				layerID = $(this).parent().attr('id');
				layerID = layerID.replace('layer_', '')
				deleteLayerFromJS(layerID, deleteGeom); 
			}
		});
		
		$('.ui-selected').each(function() { // Then, delete groups
			if ($(this).parent().hasClass("group")) { // If group
				$(this).parent().empty().remove();
			}
		});
	}
	
	
//-------------
	
	var layerContent = false
	function checkLayerForContent(layerID, layerHasContent) {
	
		if (layerHasContent == "true") { 
			layerContent = true;
		}
		
	}
	
	
//-------------
	
	
	function deleteLayerFromJS(layerID, deleteGeom) {
		if(deleteGeom == false) {
			window.location = 'skp:deleteLayerFromJS@' + layerID;
		}
		else {
			window.location = 'skp:deleteLayer&GeomFromJS@' + layerID;
		}
	}
	
	
//-------------
	
	
	function deleteLayerFromRuby(layerID) {
		$("#layer_" + layerID).empty().remove();
		storeSerialize();
	}
	
	
//-------------
	
	
	function showLayerFromJS(layerID) {
	
		window.location = 'skp:showLayerFromJS@' + layerID;
		
	}
	
	
//-------------
	
	
	function hideLayerFromJS(layerID, grouped) {
		
		window.location = 'skp:hideLayerFromJS@' + layerID;
		
	}
	
	
//-------------
	
	
	function showLayerFromRuby(layerID) {
	
		// $("span").filter(function() { return ($(this).text() === layerName) }).closest("div").children(".visibility").removeClass("hidden").addClass("visible");
		$("#layer_" + layerID).children("div").children(".visibility").removeClass("hidden").addClass("visible");
		
	}
	
	
//-------------
	
	
	function hideLayerFromRuby(layerID) {
	
		// $("span").filter(function() { return ($(this).text() === layerName) }).closest("div").children(".visibility").removeClass("visible").addClass("hidden");
		$("#layer_" + layerID).children("div").children(".visibility").removeClass("visible").addClass("hidden");
		
	}
	
	
//-------------
	
	
//-------------
	
	
	function getLayerDictID() {
	
		window.location = 'skp:getLayerDictID';
		
	}
	
	
	function receiveLayerDictID(receivedLayerDictID) {
	
		layerDictID = receivedLayerDictID;
		
	}
	
	
//-------------
	
	
	function storeSerialize() {
	
		serialized = $('ol.sortable').nestedSortable('serialize');
		window.location = 'skp:storeSerialize@' + serialized;
		
	}
	
	
//-------------
	
	
	
	
	
	
	////////////////////////
	
	
	


$(document).ready(function(){

	makeUnselectable(document);


	// $(document).bind("contextmenu", function(e) { // Disable right-click
		// return false;
	// });
	
	
	
	getModelLayers();
	getActiveLayer();

	
	

	$('ol.sortable')
		.nestedSortable({
			forcePlaceholderSize: true,
			handle: '.handle',
			helper:	'clone',
			items: 'li',
			opacity: .6,
			placeholder: 'placeholder',
			revert: 150,
			tabSize: 18,
			tolerance: 'pointer',
			toleranceElement: '> div',

			isTree: true,
			expandOnHover: 500
		})
		.selectable({cancel: ".visibility, .active, .handle, .disclose, .inputName, .layerNameText, #lidiv0", filter: ".lidiv"});
		
		
	
	$(document).on('click', '.disclose', function (e) {
		if ($(this).closest('li').hasClass('mjs-nestedSortable-collapsed')) {
			$(this).closest('li').removeClass('mjs-nestedSortable-collapsed').addClass('mjs-nestedSortable-expanded');}
		else if ($(this).closest('li').hasClass('mjs-nestedSortable-expanded')) {
			$(this).closest('li').removeClass('mjs-nestedSortable-expanded').addClass('mjs-nestedSortable-collapsed');}
		else {
			$(this).closest('li').addClass('mjs-nestedSortable-collapsed');}
	});
	

	
	$(document).on('click', '.visibility', function (e) {
		
		var  goOn = true; 
		
		if ($(this).parent().parent().hasClass("group")) { // If this is group, item = group
			var group = $(this).parent().parent();
		}
		
		while ($(this).parents(".group").hasClass("hiddenGroup")) { // If nested in hidden group, click the hidden group
			goOn = false;
			if(group) {
				if(group[0] === $(this).parents(".hiddenGroup").last()[0]) {  // Go on if this group is highest hidden group
					goOn = true; 
					group.removeClass("hiddenGroup");
				}
				else { 
					$(this).parents(".hiddenGroup").last().removeClass("hiddenGroup").children(".lidiv").children(".visibility").click();
				}
			}
			else { 
				$(this).parents(".hiddenGroup").last().removeClass("hiddenGroup").children(".lidiv").children(".visibility").click();
			}
			
			if ($(this).hasClass("hidden")) { goOn = true; }
		}
		
	
		if (goOn) { // Not nested in hidden group
	
			if ($(this).parent().parent().hasClass("group")) { // If group
				if ($(this).is(".hidden, .hiddenByGroup")) { // Hidden
					$(this).addClass("visible").removeClass("hidden");
					$(this).parent().parent().children("ol").children(".layer").children(".lidiv").children(".hiddenByGroup").each(function(i) { // Show hiddenByGrouped layers
						layerID = $(this).parent().parent().attr('id');
						layerID = layerID.replace('layer_', '');
						showLayerFromJS(layerID);
						$(this).removeClass("hiddenByGroup");
					});
					$(this).parent().parent().children("ol").find(".group").children(".lidiv").children(".hiddenByGroup").each(function(i) { // Show hiddenByGrouped groups
						$(this).click();
						$(this).removeClass("hiddenByGroup");
					});
					$(this).removeClass("hiddenGroup");
				}
				else { // visible
					if ($(this).parent().parent().children("ol").find(".layer").children(".lidiv").children(".active").hasClass("enabled")) { // If active layer is nested in this group
						alert('You cannot hide the current layer.');
					}
					else {
						$(this).addClass("hidden").removeClass("visible");
						$(this).parent().parent().addClass("hiddenGroup");
						$(this).parent().parent().children("ol").find(".layer").find(".visible:not(.hiddenByGroup)").each(function(i) { // HideGroup nested visible layers
							layerID = $(this).parent().parent().attr('id');
							layerID = layerID.replace('layer_', '');
							hideLayerFromJS(layerID);
							$(this).addClass("hiddenByGroup");
						});
						$(this).parent().parent().children("ol").find(".group").find(".visible:not(.hiddenByGroup)").each(function(i) { // HideGroup nested visible groups
							$(this).addClass("hiddenByGroup");
						});
					}
				}
			}
			
			else { // If layer
			
				if ($(this).parent().children(".active").hasClass("enabled")) { // If active layer
					alert('You cannot hide the current layer.');
				}
				
				else {	// Not active layer
					layerID = $(this).parent().parent().attr('id');
					layerID = layerID.replace('layer_', '');
					if ($(this).hasClass("visible")) {
						hideLayerFromJS(layerID);
					}
					else {
						showLayerFromJS(layerID);
					}
					// $(this).toggleClass("hidden").toggleClass("visible");
				}
			}
		
		}
	});
	

		
	$( "ol.sortable" ).on( "sortstop", function( event, ui ) { // When an item is sorted
		if (ui.item.parent().parent().hasClass('group')) { // If parent is group
			if (ui.item.children(".lidiv").children(".visibility").hasClass("visible") && ui.item.parent().parent().children(".lidiv").children(".visibility").is(".hidden, .hiddenByGroup")) {  // If item is visible, and group is hidden or hiddenByGroup
				layerID = ui.item.attr('id');
				layerID = layerID.replace('layer_', '');
				// alert(layerID);
				if (ui.item.hasClass("layer")) { // If layer, hide it
					hideLayerFromJS(layerID); 
				} 
				ui.item.children(".lidiv").children(".visibility").addClass("hiddenByGroup");
			}
		}
		else { // Item sorted outside group
			ui.item.children(".lidiv").children(".visibility").removeClass("hiddenByGroup");
			if (ui.item.hasClass("layer") && ui.item.children(".lidiv").children(".visibility").hasClass("visible")) { // If layer && visible
				layerID = ui.item.attr('id');
				layerID = layerID.replace('layer_', '');
				// alert(layerID);
				showLayerFromJS(layerID);
			}
		}
		storeSerialize();
	} );
	

	
	$(document).on('click', '.active', function (e) {
		// layerName = $(this).parent().children(".layerName").children(".layerNameText").text();
		layerID = $(this).parent().parent().attr('id');
		layerID = layerID.replace('layer_', '');
		
		if ($(this).parent().children(".visibility").hasClass("hidden")) { // Layer hidden
			showLayerFromJS(layerID);
			$(this).parent().children(".visibility").toggleClass("hidden").toggleClass("visible");
		}
		
		$(".active").removeClass("enabled").addClass("disabled");
		$(this).toggleClass("enabled").toggleClass("disabled");
		setActiveLayerFromJS(layerID);
	});
	
	
	////////////// Layer0 /////////////////
	$('#layer_0 > .lidiv > .handle').addClass('handle0').removeClass('handle');
	
	
	
	
	////////////// RENAME /////////////////
	
	//Detect double click, hide name, show input
	$(document).on('dblclick', '.layerNameText', function (e) {
		if ($(this).closest('div').parent().is('#layer_0')) {} //Can't rename Layer0
		else {
			var name = $(this).text();
			$(this).closest('div').children(".layerName").hide();
			$(this).closest('div').children(".inputName").css('display', 'block').children(".inputNameInput").val(name).focus().select();
		}
	});
	
	//Detect enter key, trigger blur
	$(document).on('keyup', '.inputNameInput', function (e) {
		if ( e.keyCode === 13 ) { // 13 is enter key
			$(this).blur();
		}
	});
	
	//Detect esc key, fetch back the old name, trigger blur
	$(document).on('keyup', '.inputNameInput', function (e) {
		if ( e.keyCode === 27 ) { // 27 is enter key
			var name = $(this).closest('div').children(".layerName").children(".layerNameText").text();
			$(this).val(name);
			$(this).blur();
		}
	});
	
	//Detect blur, hide input and transfer name
	$(document).on('blur', '.inputNameInput', function (e) {
	
		var group = false;
		if ($(this).closest('div').parent().hasClass("mjs-nestedSortable-branch")) { //If group
			var group = true;
		}
		
		var oldname = $(this).closest('div').children(".layerName").children(".layerNameText").text();
		var layerName = $(this).val();
		layerID = $(this).closest('div').parent().attr('id');
		layerID = layerID.replace('layer_', '');
		
		if( group == false && layerName.length == 0 ) { // Check if layer name is empty
			alert('Invalid Layer Name.\n\nLayer name must have at least one character.');
			$(this).focus();
		}
		
		else if ( oldname != layerName ) { // Name changes
			if ( group == false && $("span").filter(function() { return ($(this).text() === layerName) }).length) { // Check if layer name already exists
				alert('Invalid Layer Name.\n\nLayer name must be unique.');
				$(this).focus();
			}
			else {
				var layerName = $(this).val();
				$(this).closest('span').hide();
				$(this).closest('div').children(".layerName").show();
				// $(this).closest('div').children(".layerName").children(".layerNameText").text(layerName);
				if (group == false) { // If layer
					renameLayerFromJS(layerID, layerName); // Send rename to ruby
				}
				else { // If group
					var groupID = $(this).closest('div').parent().attr('id');
					renameGroup(groupID, layerName);
				}
			}
		}
		
		else { // Name doesn't change
			$(this).closest('span').hide();
			$(this).closest('div').children(".layerName").show();
		}
	});
	
	
	
	
	////////////// FOOTER ////////////////
	
	$('.footerElement').hover(function () {
		$(this).toggleClass('footerHover');
	});
	
	
	// Add a new Layer
	$('.newLayer').click(addLayerFromJS);
	
	
	// Add a new group
	$('.newGroup').click(addGroup);
	
	
	// Delete group or layer
	$('.trash').click(trash);




	////////////// MENU ////////////////
	
	
	$('.menu').click(function () {
		$('#menu').show();
	});
	$(document).mouseup(function (e){ // Hide menu on click-outside
		var container = $("#menu");

		if (container.has(e.target).length === 0)
		{
			container.hide();
		}
	});
	
	$('#purgeLayers').click(function() {
		window.location = 'skp:purgeLayersFromJS';
		$('#menu').hide();
		storeSerialize();
	});
	
	
	////////////// POPUP ////////////////
	
	//Center delete dialog on resize
	$(window).resize(function(){
		if($(window).width() > 340){ var width1 = 300 } 
		else { var width1 = $(window).width() - 40 }
		$('#wrapper').css({
			position:'absolute',
			left: ($(window).width() - $('#wrapper').outerWidth())/2,
			top: ($(window).height() - $('#wrapper').outerHeight())/2,
			width: width1
		});
	});
	// To initially run the function:
	$(window).resize();
	$(window).resize();
	

});
